unit u2Test;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, Vcl.StdCtrls,
  WEBLib.StdCtrls, Vcl.Controls, WEBLib.ExtCtrls, Vcl.Imaging.pngimage, WEBLib.Controls, WEBLib.Dialogs,
  WEBLib.ContinuousScroll, WEBLib.JSON, Web, WEBLib.WebCtrls;

type
  TForm1 = class(TWebForm)
    WebContinuousScroll1: TWebContinuousScroll;
    WebHTMLDiv1: TWebHTMLDiv;
    lbldesc: TWebLabel;
    lbltit: TWebLabel;
    WebLabel1: TWebLabel;
    WebButton1: TWebButton;
    procedure WebContinuousScroll1FetchNextPage(Sender: TObject; APageSize,
      APageNumber: Integer; var AURL: string);
    procedure WebContinuousScroll1GetListItem(Sender: TObject;
      AElementControl: TControl; AObject: TJSONObject; AIndex: Integer;
      AElement: TJSHTMLElementRecord);
    procedure WebFormCreate(Sender: TObject);
    procedure WebFormResize(Sender: TObject);
    procedure WebContinuousScroll1ItemGetFieldValue(Sender: TObject;
      AIndex: Integer; AFieldName: string; var AValue: string);
    procedure WebButton1Click(Sender: TObject);
  private
    FPostDate: TDateTime;
    procedure ButtonClick(Sender: TObject);
    procedure ImageClick(Sender: TObject);
  end;

var
  Form1: TForm1;

const
  FAVICONCLICKEDURL = 'https://tmswebcore.com/demos/ContinuousScroll/img/favourited.png';
  FAVICONURL = 'https://tmswebcore.com/demos/ContinuousScroll/img/favourite.png';
  DONEICONURL = 'https://tmswebcore.com/demos/ContinuousScroll/img/done.png';

implementation

uses
  DateUtils, Unit1;

{$R *.dfm}

procedure TForm1.ButtonClick(Sender: TObject);
var
  el: TJSElement;
begin
  el := WebContinuousScroll1.GetChildElement((Sender as TWebButton).Tag);
  el.className := 'done';
  TJSHTMLImageElement(el.getElementsByTagName('IMG')[0]).src := DONEICONURL;
  TJSHTMLElement(el.getElementsByTagName('SPAN')[0]).innerHTML := 'Done';
  el.removeChild((Sender as TWebButton).ElementHandle);
end;

procedure TForm1.ImageClick(Sender: TObject);
var
  el: TJSElement;
begin
  el := WebContinuousScroll1.GetChildElement((Sender as TWebImageControl).Tag);
  TJSHTMLElement(el.getElementsByTagName('P')[2]).innerHTML := IntToStr(StrToInt(TJSHTMLElement(el.getElementsByTagName('P')[2]).innerHTML) + 1);
  (Sender as TWebImageControl).URL := FAVICONCLICKEDURL;
  (Sender as TWebImageControl).Cursor := crDefault;
  (Sender as TWebImageControl).OnClick := nil;
end;

procedure TForm1.WebButton1Click(Sender: TObject);
begin
  Form4 := TForm4.CreateNew;
  Form4.Popup := True;
  Form4.Border := fbSingle;
  Form4.ShowModal;
end;

procedure TForm1.WebContinuousScroll1FetchNextPage(Sender: TObject; APageSize,
  APageNumber: Integer; var AURL: string);
begin
  AURL := 'https://tmswebcore.com:8082/?page=' + IntToStr(APageNumber) + '&per_page=' + IntToStr(APageSize);
end;

procedure TForm1.WebContinuousScroll1GetListItem(Sender: TObject;
  AElementControl: TControl; AObject: TJSONObject; AIndex: Integer;
  AElement: TJSHTMLElementRecord);
var
  btn: TWebButton;
  img: TWebImageControl;
begin
  case AObject.GetJSONValue('status') of
    'Done': AElement.element.className := 'done';
    'Low priority': AElement.element.className := 'low_prior';
    'Medium priority': AElement.element.className := 'med_prior';
    'Urgent': AElement.element.className := 'urgent';
  end;

  if AObject.GetJSONValue('status') = 'Urgent' then
  begin
    btn := TWebButton.Create(AElementControl);
    btn.Parent := AElementControl;
    btn.Cursor := crHandPoint;
    btn.ElementClassName := 'done-button';
    btn.Caption := 'Mark as done';
    btn.Width := 120;
    btn.Height := 30;
    btn.Left := 85;
    btn.Top := 35;
    btn.ElementHandle.style.setProperty('font-size', '12pt');
    btn.Tag := AIndex;
    btn.OnClick := ButtonClick;
  end;

  img := TWebImageControl.Create(AElementControl);
  img.Parent := AElementControl;
  img.ElementPosition := epIgnore;
  img.URL := FAVICONURL;
  img.Width := 16;
  img.Height := 16;
  img.Cursor := crHandPoint;
  img.Tag := AIndex;
  img.OnClick := ImageClick;
  img.ElementHandle.style.setProperty('padding-left', '10px');

  AElement.element.insertBefore(img.ElementHandle, AElement.element.getElementsByTagName('p')[2]);
end;

procedure TForm1.WebContinuousScroll1ItemGetFieldValue(Sender: TObject;
  AIndex: Integer; AFieldName: string; var AValue: string);
begin
  if AFieldName = 'date' then
  begin
    FPostDate := IncSecond(FPostDate, -Random(3600));
    AValue := DateTimeToStr(FPostDate);
  end;
end;

procedure TForm1.WebFormCreate(Sender: TObject);
begin
  FPostDate := Now;
end;

procedure TForm1.WebFormResize(Sender: TObject);
begin
  WebContinuousScroll1.Left := (Self.Width - WebContinuousScroll1.Width) div 2;
end;

end.
